<?php

namespace Modules\Package\Controllers\Admin;

/** Ajax Request */

use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Controllers\Controller;
use Modules\Feature\Enums\FeatureTypeEnum;
use Modules\Feature\Services\FeatureService;
use Modules\Package\Requests\Admin\PackageRequest;
use Modules\Package\Services\PackageService;
use Modules\Currency\Services\CurrencyService;

class PackageController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/packages';
    /** View folder */
    private $viewDirectory= 'admin.packages.';
    //

    public function __construct(
        private PackageService $packageService,
        private FeatureService $featureService
    )
    {}

    /**
     * Display a listing of the packages.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('packages.head');
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the packages.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $request->merge(['paginate'=>true]);
        $packages= $this->packageService->get($request->all());

        return view($this->viewDirectory.'grid',get_defined_vars());
    }

    /**
     * Show the form for creating a new Package.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('packages.store');
        $head= __('packages.new');
        $features = [];
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created Package in storage.
     * @param PackageRequest $request
     * @return JsonResponse
     */
    public function store(PackageRequest $request) :JsonResponse
    {
        $this->packageService->create($request->validated());

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('packages.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified Package.
     *
     * @param  int $id
     * @return View
     */
    public function edit(int $id) :View
    {
        $package = $this->packageService->getItem($id);
        if (!$package)
        {
            abort(404);
        }
        $action= route('packages.update', $package->id);
        $head= __('packages.edit');
        $features = $this->featureService->get([
            'featureable_id'=>$package->id,
            'featureable_type'=>FeatureTypeEnum::PACKAGE->value
        ]);
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified Package in storage.
     * @param PackageRequest $request
     * @param int $id
     * @return JsonResponse
     */
    public function update(PackageRequest $request, int $id) :JsonResponse
    {
        $package = $this->packageService->checkItem($id);
        if (!$package)
        {
            abort(404);
        }
        $this->packageService->update($request->validated(), $id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('packages.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified Package from storage.
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(int $id) :JsonResponse
    {
        $this->packageService->destroy($id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('packages.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove several packages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $this->packageService->destroyAll([
            'ids' => $request->ids,
            'status' => 1
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('packages.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore the specified Package from storage.
     *
     * @param int $id
     * @return JsonResponse
     */
    public function restore(int $id) :JsonResponse
    {
        $this->packageService->destroy($id);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('packages.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore several packages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $this->packageService->destroyAll([
            'ids' => $request->ids,
            'status' => 0
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('packages.index'),
        ];
        return ResponseService::response($response);
    }
}
